Blame


1 0e673013 2019-01-02 stsp #!/bin/sh
2 0e673013 2019-01-02 stsp #
3 5aa81393 2020-01-06 stsp # Copyright (c) 2019, 2020 Stefan Sperling <stsp@openbsd.org>
4 0e673013 2019-01-02 stsp #
5 0e673013 2019-01-02 stsp # Permission to use, copy, modify, and distribute this software for any
6 0e673013 2019-01-02 stsp # purpose with or without fee is hereby granted, provided that the above
7 0e673013 2019-01-02 stsp # copyright notice and this permission notice appear in all copies.
8 0e673013 2019-01-02 stsp #
9 0e673013 2019-01-02 stsp # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 0e673013 2019-01-02 stsp # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 0e673013 2019-01-02 stsp # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 0e673013 2019-01-02 stsp # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 0e673013 2019-01-02 stsp # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 0e673013 2019-01-02 stsp # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 0e673013 2019-01-02 stsp # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
16 0e673013 2019-01-02 stsp
17 f81387ac 2023-02-17 thomas regress_run_only=""
18 f81387ac 2023-02-17 thomas
19 0b2899f8 2019-08-18 stsp export GIT_AUTHOR_NAME="Flan Hacker"
20 0b2899f8 2019-08-18 stsp export GIT_AUTHOR_EMAIL="flan_hacker@openbsd.org"
21 0b2899f8 2019-08-18 stsp export GIT_COMMITTER_NAME="$GIT_AUTHOR_NAME"
22 0b2899f8 2019-08-18 stsp export GIT_COMMITTER_EMAIL="$GIT_AUTHOR_EMAIL"
23 0b2899f8 2019-08-18 stsp export GOT_AUTHOR="$GIT_AUTHOR_NAME <$GIT_AUTHOR_EMAIL>"
24 82f6abb8 2019-08-14 stsp export GOT_AUTHOR_8="flan_hac"
25 e600f124 2021-03-21 stsp export GOT_AUTHOR_11="flan_hacker"
26 b1ebc001 2019-08-13 stsp export GOT_LOG_DEFAULT_LIMIT=0
27 11f4fa81 2020-10-01 stsp export GOT_TEST_ROOT="/tmp"
28 1f240092 2022-07-24 thomas export GOT_IGNORE_GITCONFIG=1
29 113392cf 2023-01-23 thomas export GOT_VERSION_STR=`got --version | cut -d ' ' -f2`
30 c3754a5b 2019-05-10 stsp
31 7b67836a 2019-05-10 stsp export MALLOC_OPTIONS=S
32 d3b82051 2022-07-10 thomas
33 d3b82051 2022-07-10 thomas # Check to see if PLATFORM has a value. PLATFORM is populated when running
34 d3b82051 2022-07-10 thomas # via `./configure && make` but this isn't guaranteed if an individual test is
35 d3b82051 2022-07-10 thomas # run directly, such as `regress/cmdline/tag.sh`. In such cases, PLATFORM
36 d3b82051 2022-07-10 thomas # will be empty, but we still want to use it. Since we test for non-linux
37 d3b82051 2022-07-10 thomas # values, only set PLATFORM if we're running on Linu so that the correct
38 d3b82051 2022-07-10 thomas # commands are used.
39 980b1615 2022-07-11 thomas [ -z "$PLATFORM" -a "$(uname)" = "Linux" ] && PLATFORM="linux"
40 7b67836a 2019-05-10 stsp
41 1c72bab5 2023-03-03 thomas [ "$(date -u -r 86400 +%F 2>/dev/null)" = 1970-01-02 ] || date()
42 fa37079f 2021-10-09 thomas {
43 fa37079f 2021-10-09 thomas DATECMD="date"
44 e8da6c41 2022-07-10 thomas [ "$PLATFORM" != "linux" ] && {
45 e8da6c41 2022-07-10 thomas command -v "gdate" >/dev/null 2>&1 && {
46 e8da6c41 2022-07-10 thomas DATECMD="gdate"
47 e8da6c41 2022-07-10 thomas } || {
48 cc5596d8 2022-07-11 thomas echo "Couldn't find gdate is GNU coreutils installed?"
49 e8da6c41 2022-07-10 thomas }
50 e8da6c41 2022-07-10 thomas }
51 1c72bab5 2023-03-03 thomas
52 1c72bab5 2023-03-03 thomas local flag r u
53 1c72bab5 2023-03-03 thomas while getopts r:u flag; do
54 1c72bab5 2023-03-03 thomas case $flag in
55 1c72bab5 2023-03-03 thomas r) r=$OPTARG ;;
56 1c72bab5 2023-03-03 thomas u) u=-u ;;
57 1c72bab5 2023-03-03 thomas ?) exit 1 ;;
58 1c72bab5 2023-03-03 thomas esac
59 1c72bab5 2023-03-03 thomas done
60 1c72bab5 2023-03-03 thomas shift $((OPTIND - 1))
61 1c72bab5 2023-03-03 thomas command "$DATECMD" $u ${r+-d"@$r"} "$@"
62 fa37079f 2021-10-09 thomas }
63 fa37079f 2021-10-09 thomas
64 c206b220 2021-10-09 thomas sed()
65 c206b220 2021-10-09 thomas {
66 c206b220 2021-10-09 thomas SEDCMD="sed"
67 186c23b6 2022-03-08 thomas
68 186c23b6 2022-03-08 thomas # On non-linux systems, the sed command can happily accept "-i ''" as
69 186c23b6 2022-03-08 thomas # a valid command to not save backup files for in-place edits.
70 186c23b6 2022-03-08 thomas # However, on linux, "-i ''" would be treated as "-i" with a blank
71 186c23b6 2022-03-08 thomas # argument, and hence, no file to edit in-place, which is an error.
72 186c23b6 2022-03-08 thomas #
73 186c23b6 2022-03-08 thomas # Therefore, scan the argument list and remove "-i ''", replacing it
74 186c23b6 2022-03-08 thomas # with just "-i".
75 432c637b 2022-07-11 thomas
76 1ff9fea4 2021-11-23 thomas [ "$PLATFORM" = "linux" ] && {
77 432c637b 2022-07-11 thomas for w in "$@"
78 432c637b 2022-07-11 thomas do
79 432c637b 2022-07-11 thomas [ "$w" = "-i" ] && {
80 432c637b 2022-07-11 thomas seen=1
81 432c637b 2022-07-11 thomas continue
82 432c637b 2022-07-11 thomas }
83 432c637b 2022-07-11 thomas
84 432c637b 2022-07-11 thomas [ "$seen" = "1" -a -z "$w" ] && {
85 432c637b 2022-07-11 thomas # Move past -i and ''
86 186c23b6 2022-03-08 thomas shift 2
87 432c637b 2022-07-11 thomas
88 0a046396 2022-07-12 thomas command "$SEDCMD" -i "$@"
89 186c23b6 2022-03-08 thomas return
90 186c23b6 2022-03-08 thomas }
91 186c23b6 2022-03-08 thomas done
92 c206b220 2021-10-09 thomas }
93 0a046396 2022-07-12 thomas command "$SEDCMD" "$@"
94 c206b220 2021-10-09 thomas }
95 fa37079f 2021-10-09 thomas
96 fa37079f 2021-10-09 thomas
97 f6cae3ed 2020-09-13 naddy git_init()
98 0e673013 2019-01-02 stsp {
99 0b2899f8 2019-08-18 stsp git init -q "$1"
100 f60607c8 2021-09-30 thomas
101 f60607c8 2021-09-30 thomas # Switch the default branch to match our test expectations if needed.
102 f60607c8 2021-09-30 thomas # Only need to change HEAD since 'git init' did not create any refs.
103 f60607c8 2021-09-30 thomas # Relying on implementation details of 'git init' is no problem for us.
104 f60607c8 2021-09-30 thomas # We want to be alerted when Git changes fundamental assumptions such
105 f60607c8 2021-09-30 thomas # as what an empty repository looks like and where the default branch
106 f60607c8 2021-09-30 thomas # is set. In such cases Got's own tooling might well need to change
107 f60607c8 2021-09-30 thomas # its behaviour, too, and our tests should fail.
108 f60607c8 2021-09-30 thomas # TODO: Update all tests to assume 'main' instead of 'master' and
109 f60607c8 2021-09-30 thomas # switch to main here, to match Got's own default.
110 f60607c8 2021-09-30 thomas echo "ref: refs/heads/master" > "$1/.git/HEAD"
111 0e673013 2019-01-02 stsp }
112 0e673013 2019-01-02 stsp
113 f6cae3ed 2020-09-13 naddy maybe_pack_repo()
114 b32c4525 2020-01-05 stsp {
115 b32c4525 2020-01-05 stsp local repo="$1"
116 b32c4525 2020-01-05 stsp if [ -n "$GOT_TEST_PACK" ]; then
117 a628577a 2023-02-17 thomas arg=""
118 a628577a 2023-02-17 thomas if [ "$GOT_TEST_PACK" = "ref-delta" ]; then
119 a628577a 2023-02-17 thomas arg="-D"
120 a628577a 2023-02-17 thomas fi
121 a628577a 2023-02-17 thomas
122 a628577a 2023-02-17 thomas (cd $repo && gotadmin pack -a $arg > /dev/null)
123 a628577a 2023-02-17 thomas (cd $repo && gotadmin cleanup -a -q)
124 b32c4525 2020-01-05 stsp fi
125 b32c4525 2020-01-05 stsp }
126 b32c4525 2020-01-05 stsp
127 f6cae3ed 2020-09-13 naddy git_commit()
128 0e673013 2019-01-02 stsp {
129 0e673013 2019-01-02 stsp local repo="$1"
130 0e673013 2019-01-02 stsp shift
131 0b2899f8 2019-08-18 stsp (cd $repo && git commit --author="$GOT_AUTHOR" -q -a "$@")
132 b32c4525 2020-01-05 stsp maybe_pack_repo $repo
133 0e673013 2019-01-02 stsp }
134 0e673013 2019-01-02 stsp
135 f6cae3ed 2020-09-13 naddy git_rm()
136 512f0d0e 2019-01-02 stsp {
137 512f0d0e 2019-01-02 stsp local repo="$1"
138 512f0d0e 2019-01-02 stsp shift
139 512f0d0e 2019-01-02 stsp (cd $repo && git rm -q "$@")
140 512f0d0e 2019-01-02 stsp }
141 512f0d0e 2019-01-02 stsp
142 f6cae3ed 2020-09-13 naddy git_show_head()
143 9c4b8182 2019-01-02 stsp {
144 9c4b8182 2019-01-02 stsp local repo="$1"
145 9c4b8182 2019-01-02 stsp (cd $repo && git show --no-patch --pretty='format:%H')
146 9c4b8182 2019-01-02 stsp }
147 9c4b8182 2019-01-02 stsp
148 f6cae3ed 2020-09-13 naddy git_show_branch_head()
149 db32465d 2020-02-07 stsp {
150 db32465d 2020-02-07 stsp local repo="$1"
151 db32465d 2020-02-07 stsp local branch="$2"
152 db32465d 2020-02-07 stsp (cd $repo && git show --no-patch --pretty='format:%H' $branch)
153 db32465d 2020-02-07 stsp }
154 db32465d 2020-02-07 stsp
155 db32465d 2020-02-07 stsp
156 f6cae3ed 2020-09-13 naddy git_show_author_time()
157 bcb49d15 2019-08-14 stsp {
158 bcb49d15 2019-08-14 stsp local repo="$1"
159 01073a5d 2019-08-22 stsp local object="$2"
160 01073a5d 2019-08-22 stsp (cd $repo && git show --no-patch --pretty='format:%at' $object)
161 bcb49d15 2019-08-14 stsp }
162 bcb49d15 2019-08-14 stsp
163 f6cae3ed 2020-09-13 naddy git_show_tagger_time()
164 8e7bd50a 2019-08-22 stsp {
165 8e7bd50a 2019-08-22 stsp local repo="$1"
166 8e7bd50a 2019-08-22 stsp local tag="$2"
167 8e7bd50a 2019-08-22 stsp (cd $repo && git cat-file tag $tag | grep ^tagger | \
168 8e7bd50a 2019-08-22 stsp sed -e "s/^tagger $GOT_AUTHOR//" | cut -d' ' -f2)
169 8e7bd50a 2019-08-22 stsp }
170 8e7bd50a 2019-08-22 stsp
171 f6cae3ed 2020-09-13 naddy git_show_parent_commit()
172 818c7501 2019-07-11 stsp {
173 818c7501 2019-07-11 stsp local repo="$1"
174 70551d57 2020-04-24 stsp local commit="$2"
175 70551d57 2020-04-24 stsp (cd $repo && git show --no-patch --pretty='format:%P' $commit)
176 818c7501 2019-07-11 stsp }
177 818c7501 2019-07-11 stsp
178 f6cae3ed 2020-09-13 naddy git_show_tree()
179 03415a1a 2019-06-02 stsp {
180 03415a1a 2019-06-02 stsp local repo="$1"
181 03415a1a 2019-06-02 stsp (cd $repo && git show --no-patch --pretty='format:%T')
182 03415a1a 2019-06-02 stsp }
183 03415a1a 2019-06-02 stsp
184 f6cae3ed 2020-09-13 naddy trim_obj_id()
185 818c7501 2019-07-11 stsp {
186 9439a990 2020-09-16 naddy local trimcount=$1
187 9439a990 2020-09-16 naddy local id=$2
188 818c7501 2019-07-11 stsp
189 9439a990 2020-09-16 naddy local pat=""
190 9439a990 2020-09-16 naddy while [ "$trimcount" -gt 0 ]; do
191 818c7501 2019-07-11 stsp pat="[0-9a-f]$pat"
192 9439a990 2020-09-16 naddy trimcount=$((trimcount - 1))
193 818c7501 2019-07-11 stsp done
194 818c7501 2019-07-11 stsp
195 818c7501 2019-07-11 stsp echo ${id%$pat}
196 818c7501 2019-07-11 stsp }
197 818c7501 2019-07-11 stsp
198 f6cae3ed 2020-09-13 naddy git_commit_tree()
199 03415a1a 2019-06-02 stsp {
200 03415a1a 2019-06-02 stsp local repo="$1"
201 03415a1a 2019-06-02 stsp local msg="$2"
202 03415a1a 2019-06-02 stsp local tree="$3"
203 03415a1a 2019-06-02 stsp (cd $repo && git commit-tree -m "$msg" "$tree")
204 03415a1a 2019-06-02 stsp }
205 03415a1a 2019-06-02 stsp
206 f0fd0aaf 2021-09-14 stsp git_fsck()
207 f0fd0aaf 2021-09-14 stsp {
208 f0fd0aaf 2021-09-14 stsp local testroot="$1"
209 f0fd0aaf 2021-09-14 stsp local repo="$2"
210 f0fd0aaf 2021-09-14 stsp
211 f0fd0aaf 2021-09-14 stsp (cd $repo && git fsck --strict \
212 f0fd0aaf 2021-09-14 stsp > $testroot/fsck.stdout 2> $testroot/fsck.stderr)
213 fc414659 2022-04-16 thomas ret=$?
214 fc414659 2022-04-16 thomas if [ $ret -ne 0 ]; then
215 f0fd0aaf 2021-09-14 stsp echo -n "git fsck: "
216 f0fd0aaf 2021-09-14 stsp cat $testroot/fsck.stderr
217 f0fd0aaf 2021-09-14 stsp echo "git fsck failed; leaving test data in $testroot"
218 f0fd0aaf 2021-09-14 stsp return 1
219 f0fd0aaf 2021-09-14 stsp fi
220 f0fd0aaf 2021-09-14 stsp
221 f0fd0aaf 2021-09-14 stsp return 0
222 f0fd0aaf 2021-09-14 stsp }
223 f0fd0aaf 2021-09-14 stsp
224 f6cae3ed 2020-09-13 naddy make_test_tree()
225 0e673013 2019-01-02 stsp {
226 0e673013 2019-01-02 stsp repo="$1"
227 0e673013 2019-01-02 stsp
228 0e673013 2019-01-02 stsp echo alpha > $repo/alpha
229 0e673013 2019-01-02 stsp echo beta > $repo/beta
230 0e673013 2019-01-02 stsp mkdir $repo/gamma
231 0e673013 2019-01-02 stsp echo delta > $repo/gamma/delta
232 0e673013 2019-01-02 stsp mkdir $repo/epsilon
233 0e673013 2019-01-02 stsp echo zeta > $repo/epsilon/zeta
234 0e673013 2019-01-02 stsp }
235 0e673013 2019-01-02 stsp
236 f6cae3ed 2020-09-13 naddy make_single_file_repo()
237 e7303626 2020-05-14 stsp {
238 e7303626 2020-05-14 stsp repo="$1"
239 e7303626 2020-05-14 stsp file="$2"
240 e7303626 2020-05-14 stsp
241 e7303626 2020-05-14 stsp mkdir $repo
242 e7303626 2020-05-14 stsp git_init $repo
243 e7303626 2020-05-14 stsp echo "this is file $file" > $repo/$file
244 e7303626 2020-05-14 stsp (cd $repo && git add .)
245 e7303626 2020-05-14 stsp git_commit $repo -m "intialize $repo with file $file"
246 e7303626 2020-05-14 stsp }
247 e7303626 2020-05-14 stsp
248 f6cae3ed 2020-09-13 naddy get_loose_object_path()
249 e7303626 2020-05-14 stsp {
250 e7303626 2020-05-14 stsp local repo="$1"
251 e7303626 2020-05-14 stsp local id="$2"
252 e7303626 2020-05-14 stsp local id0=`trim_obj_id 38 $id`
253 e7303626 2020-05-14 stsp local idrest=`echo ${id#[0-9a-f][0-9a-f]}`
254 e7303626 2020-05-14 stsp echo "$repo/.git/objects/$id0/$idrest"
255 e7303626 2020-05-14 stsp }
256 e7303626 2020-05-14 stsp
257 f6cae3ed 2020-09-13 naddy get_blob_id()
258 3ce1b845 2019-07-15 stsp {
259 3ce1b845 2019-07-15 stsp repo="$1"
260 3ce1b845 2019-07-15 stsp tree_path="$2"
261 3ce1b845 2019-07-15 stsp filename="$3"
262 3ce1b845 2019-07-15 stsp
263 e8863bdc 2020-07-23 stsp got tree -r $repo -i $tree_path | grep "[0-9a-f] ${filename}$" | \
264 e8863bdc 2020-07-23 stsp cut -d' ' -f 1
265 3ce1b845 2019-07-15 stsp }
266 3ce1b845 2019-07-15 stsp
267 f6cae3ed 2020-09-13 naddy test_init()
268 0e673013 2019-01-02 stsp {
269 0e673013 2019-01-02 stsp local testname="$1"
270 4a1ddfc2 2019-01-12 stsp local no_tree="$2"
271 0e673013 2019-01-02 stsp if [ -z "$testname" ]; then
272 0e673013 2019-01-02 stsp echo "No test name provided" >&2
273 0e673013 2019-01-02 stsp return 1
274 0e673013 2019-01-02 stsp fi
275 e5a14fe3 2020-10-01 stsp local testroot=`mktemp -d "$GOT_TEST_ROOT/got-test-$testname-XXXXXXXX"`
276 0e673013 2019-01-02 stsp mkdir $testroot/repo
277 0e673013 2019-01-02 stsp git_init $testroot/repo
278 4a1ddfc2 2019-01-12 stsp if [ -z "$no_tree" ]; then
279 4a1ddfc2 2019-01-12 stsp make_test_tree $testroot/repo
280 3ce1b845 2019-07-15 stsp (cd $repo && git add .)
281 4a1ddfc2 2019-01-12 stsp git_commit $testroot/repo -m "adding the test tree"
282 4a1ddfc2 2019-01-12 stsp fi
283 c8c71e6e 2020-03-21 stsp touch $testroot/repo/.git/git-daemon-export-ok
284 0e673013 2019-01-02 stsp echo "$testroot"
285 0e673013 2019-01-02 stsp }
286 0e673013 2019-01-02 stsp
287 f6cae3ed 2020-09-13 naddy test_cleanup()
288 0e673013 2019-01-02 stsp {
289 0e673013 2019-01-02 stsp local testroot="$1"
290 fe7842f5 2019-07-14 stsp
291 f0fd0aaf 2021-09-14 stsp git_fsck $testroot $testroot/repo
292 fc414659 2022-04-16 thomas ret=$?
293 fc414659 2022-04-16 thomas if [ $ret -ne 0 ]; then
294 f0fd0aaf 2021-09-14 stsp return $ret
295 fe7842f5 2019-07-14 stsp fi
296 fe7842f5 2019-07-14 stsp
297 0e673013 2019-01-02 stsp rm -rf "$testroot"
298 0e673013 2019-01-02 stsp }
299 0e673013 2019-01-02 stsp
300 f6cae3ed 2020-09-13 naddy test_parseargs()
301 7fb414ae 2020-08-08 stsp {
302 6c8da0c6 2020-10-03 naddy while getopts qr: flag; do
303 6c8da0c6 2020-10-03 naddy case $flag in
304 6c8da0c6 2020-10-03 naddy q) export GOT_TEST_QUIET=1
305 6c8da0c6 2020-10-03 naddy ;;
306 4f3c3d1e 2023-01-10 thomas r) export GOT_TEST_ROOT=${OPTARG%/}
307 6c8da0c6 2020-10-03 naddy ;;
308 6c8da0c6 2020-10-03 naddy ?) echo "Supported options:"
309 6c8da0c6 2020-10-03 naddy echo " -q: quiet mode"
310 6c8da0c6 2020-10-03 naddy echo " -r PATH: use PATH as test data root directory"
311 6c8da0c6 2020-10-03 naddy exit 2
312 6c8da0c6 2020-10-03 naddy ;;
313 7fb414ae 2020-08-08 stsp esac
314 7fb414ae 2020-08-08 stsp done
315 f81387ac 2023-02-17 thomas shift $(($OPTIND - 1))
316 f81387ac 2023-02-17 thomas regress_run_only="$@"
317 6c8da0c6 2020-10-03 naddy } >&2
318 7fb414ae 2020-08-08 stsp
319 f6cae3ed 2020-09-13 naddy run_test()
320 0e673013 2019-01-02 stsp {
321 0e673013 2019-01-02 stsp testfunc="$1"
322 f81387ac 2023-02-17 thomas
323 f81387ac 2023-02-17 thomas if [ -n "$regress_run_only" ]; then
324 f81387ac 2023-02-17 thomas case "$regress_run_only" in
325 f81387ac 2023-02-17 thomas *$testfunc*) ;;
326 f81387ac 2023-02-17 thomas *) return ;;
327 f81387ac 2023-02-17 thomas esac
328 f81387ac 2023-02-17 thomas fi
329 f81387ac 2023-02-17 thomas
330 7fb414ae 2020-08-08 stsp if [ -z "$GOT_TEST_QUIET" ]; then
331 7fb414ae 2020-08-08 stsp echo -n "$testfunc "
332 7fb414ae 2020-08-08 stsp fi
333 0e673013 2019-01-02 stsp $testfunc
334 0e673013 2019-01-02 stsp }
335 0e673013 2019-01-02 stsp
336 f6cae3ed 2020-09-13 naddy test_done()
337 0e673013 2019-01-02 stsp {
338 0e673013 2019-01-02 stsp local testroot="$1"
339 0e673013 2019-01-02 stsp local result="$2"
340 54c39596 2020-12-28 stsp if [ "$result" = "0" ]; then
341 fe7842f5 2019-07-14 stsp test_cleanup "$testroot" || return 1
342 7fb414ae 2020-08-08 stsp if [ -z "$GOT_TEST_QUIET" ]; then
343 7fb414ae 2020-08-08 stsp echo "ok"
344 7fb414ae 2020-08-08 stsp fi
345 3941b73a 2019-05-14 stsp elif echo "$result" | grep -q "^xfail"; then
346 3941b73a 2019-05-14 stsp # expected test failure; test reproduces an unfixed bug
347 3941b73a 2019-05-14 stsp echo "$result"
348 17201126 2019-07-14 stsp test_cleanup "$testroot" || return 1
349 0e673013 2019-01-02 stsp else
350 0e673013 2019-01-02 stsp echo "test failed; leaving test data in $testroot"
351 0e673013 2019-01-02 stsp fi
352 0e673013 2019-01-02 stsp }